diff --git a/tests/data/config_sample_2.lio b/tests/data/config_sample_2.lio
new file mode 100644
index 0000000..b92f726
--- /dev/null
+++ b/tests/data/config_sample_2.lio
@@ -0,0 +1,208 @@
+storage fileio {
+    disk file_buffered_1MB {
+        buffered yes 
+        path /tmp/file_buffered_1MB 
+        size 1.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache yes 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 1 
+            max_unmap_lba_count 8192 
+            max_write_same_len 4096 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity 1 
+            unmap_granularity_alignment 0 
+        }
+    }
+    disk file_no_option_2MB {
+        buffered yes 
+        path /tmp/file_no_option_2MB 
+        size 2.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache yes 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 1 
+            max_unmap_lba_count 8192 
+            max_write_same_len 4096 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity 1 
+            unmap_granularity_alignment 0 
+        }
+    }
+    disk file_sparse_1MB {
+        buffered yes 
+        path /tmp/file_sparse_1MB 
+        size 1.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache yes 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 1 
+            max_unmap_lba_count 8192 
+            max_write_same_len 4096 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity 1 
+            unmap_granularity_alignment 0 
+        }
+    }
+}
+fabric iscsi {
+    discovery_auth {
+        enable no 
+        mutual_password "" 
+        mutual_userid "" 
+        password "" 
+        userid "" 
+    }
+    target iqn.2003-01.org.linux-iscsi.ws0.x8664:sn.31631c361eba tpgt 1 {
+        enable yes 
+        attribute {
+            authentication yes 
+            cache_dynamic_acls no 
+            default_cmdsn_depth 64 
+            default_erl 0 
+            demo_mode_discovery yes 
+            demo_mode_write_protect yes 
+            generate_node_acls no 
+            login_timeout 15 
+            netif_timeout 2 
+            prod_mode_write_protect no 
+        }
+        auth {
+            password "" 
+            password_mutual "" 
+            userid "" 
+            userid_mutual "" 
+        }
+        parameter {
+            AuthMethod CHAP 
+            DataDigest "CRC32C,None" 
+            DataPDUInOrder yes 
+            DataSequenceInOrder yes 
+            DefaultTime2Retain 20 
+            DefaultTime2Wait 2 
+            ErrorRecoveryLevel no 
+            FirstBurstLength 65536 
+            HeaderDigest "CRC32C,None" 
+            IFMarkInt "2048~65535" 
+            IFMarker no 
+            ImmediateData yes 
+            InitialR2T yes 
+            MaxBurstLength 262144 
+            MaxConnections 1 
+            MaxOutstandingR2T 1 
+            MaxRecvDataSegmentLength 8192 
+            MaxXmitDataSegmentLength 262144 
+            OFMarkInt "2048~65535" 
+            OFMarker no 
+            TargetAlias "LIO Target" 
+        }
+        lun 0 backend fileio:file_buffered_1MB 
+        lun 1 backend fileio:file_no_option_2MB 
+        lun 2 backend fileio:file_sparse_1MB 
+        acl iqn.2003-01.org.linux-iscsi.ws0.x8664:client1 {
+            attribute {
+                dataout_timeout 3 
+                dataout_timeout_retries 5 
+                default_erl 0 
+                nopin_response_timeout 30 
+                nopin_timeout 15 
+                random_datain_pdu_offsets no 
+                random_datain_seq_offsets no 
+                random_r2t_offsets no 
+            }
+            auth {
+                password "" 
+                password_mutual "" 
+                userid "" 
+                userid_mutual "" 
+            }
+            mapped_lun 0 {
+                target_lun 0 
+                write_protect no 
+            }
+            mapped_lun 1 {
+                target_lun 1 
+                write_protect no 
+            }
+            mapped_lun 2 {
+                target_lun 2 
+                write_protect no 
+            }
+        }
+        acl iqn.2003-01.org.linux-iscsi.ws0.x8664:client2 {
+            attribute {
+                dataout_timeout 3 
+                dataout_timeout_retries 5 
+                default_erl 0 
+                nopin_response_timeout 30 
+                nopin_timeout 15 
+                random_datain_pdu_offsets no 
+                random_datain_seq_offsets no 
+                random_r2t_offsets no 
+            }
+            auth {
+                password "" 
+                password_mutual "" 
+                userid "" 
+                userid_mutual "" 
+            }
+            mapped_lun 0 {
+                target_lun 0 
+                write_protect no 
+            }
+            mapped_lun 1 {
+                target_lun 1 
+                write_protect no 
+            }
+            mapped_lun 2 {
+                target_lun 2 
+                write_protect no 
+            }
+        }
+    }
+}
diff --git a/tests/data/config_sample_3.lio b/tests/data/config_sample_3.lio
new file mode 100644
index 0000000..172455c
--- /dev/null
+++ b/tests/data/config_sample_3.lio
@@ -0,0 +1,204 @@
+storage fileio {
+    disk file_no_option_2MB {
+        buffered yes 
+        path /tmp/file_no_option_2MB 
+        size 2.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache yes 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 1 
+            max_unmap_lba_count 8192 
+            max_write_same_len 4096 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity 1 
+            unmap_granularity_alignment 0 
+        }
+    }
+    disk file_sparse_1MB {
+        buffered yes 
+        path /tmp/file_sparse_1MB 
+        size 1.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache yes 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 1 
+            max_unmap_lba_count 8192 
+            max_write_same_len 4096 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity 1 
+            unmap_granularity_alignment 0 
+        }
+    }
+    disk file_unbuffered_1MB {
+        buffered yes 
+        path /tmp/file_unbuffered_1MB 
+        size 1.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache yes 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 1 
+            max_unmap_lba_count 8192 
+            max_write_same_len 4096 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity 1 
+            unmap_granularity_alignment 0 
+        }
+    }
+}
+fabric iscsi {
+    discovery_auth {
+        enable no 
+        mutual_password "" 
+        mutual_userid "" 
+        password "" 
+        userid "" 
+    }
+    target iqn.2003-01.org.linux-iscsi.ws0.x8664:sn.31631c361eba tpgt 1 {
+        enable yes 
+        attribute {
+            authentication yes 
+            cache_dynamic_acls no 
+            default_cmdsn_depth 64 
+            default_erl 0 
+            demo_mode_discovery yes 
+            demo_mode_write_protect yes 
+            generate_node_acls no 
+            login_timeout 15 
+            netif_timeout 2 
+            prod_mode_write_protect no 
+        }
+        auth {
+            password "" 
+            password_mutual "" 
+            userid "" 
+            userid_mutual "" 
+        }
+        parameter {
+            AuthMethod CHAP 
+            DataDigest "CRC32C,None" 
+            DataPDUInOrder yes 
+            DataSequenceInOrder yes 
+            DefaultTime2Retain 20 
+            DefaultTime2Wait 2 
+            ErrorRecoveryLevel no 
+            FirstBurstLength 65536 
+            HeaderDigest "CRC32C,None" 
+            IFMarkInt "2048~65535" 
+            IFMarker no 
+            ImmediateData yes 
+            InitialR2T yes 
+            MaxBurstLength 262144 
+            MaxConnections 1 
+            MaxOutstandingR2T 1 
+            MaxRecvDataSegmentLength 8192 
+            MaxXmitDataSegmentLength 262144 
+            OFMarkInt "2048~65535" 
+            OFMarker no 
+            TargetAlias "LIO Target" 
+        }
+        lun 1 backend fileio:file_no_option_2MB 
+        lun 2 backend fileio:file_sparse_1MB 
+        acl iqn.2003-01.org.linux-iscsi.ws0.x8664:client1 {
+            attribute {
+                dataout_timeout 3 
+                dataout_timeout_retries 5 
+                default_erl 0 
+                nopin_response_timeout 30 
+                nopin_timeout 15 
+                random_datain_pdu_offsets no 
+                random_datain_seq_offsets no 
+                random_r2t_offsets no 
+            }
+            auth {
+                password "" 
+                password_mutual "" 
+                userid "" 
+                userid_mutual "" 
+            }
+            mapped_lun 1 {
+                target_lun 1 
+                write_protect no 
+            }
+            mapped_lun 2 {
+                target_lun 2 
+                write_protect no 
+            }
+        }
+        acl iqn.2003-01.org.linux-iscsi.ws0.x8664:client2 {
+            attribute {
+                dataout_timeout 3 
+                dataout_timeout_retries 5 
+                default_erl 0 
+                nopin_response_timeout 30 
+                nopin_timeout 15 
+                random_datain_pdu_offsets no 
+                random_datain_seq_offsets no 
+                random_r2t_offsets no 
+            }
+            auth {
+                password "" 
+                password_mutual "" 
+                userid "" 
+                userid_mutual "" 
+            }
+            mapped_lun 1 {
+                target_lun 1 
+                write_protect no 
+            }
+            mapped_lun 2 {
+                target_lun 2 
+                write_protect no 
+            }
+        }
+    }
+}
+fabric loopback target naa.60014054793b60dd {
+    lun 0 backend fileio:file_no_option_2MB 
+    lun 1 backend fileio:file_sparse_1MB 
+    lun 2 backend fileio:file_unbuffered_1MB 
+}
diff --git a/tests/data/config_sample_4.lio b/tests/data/config_sample_4.lio
new file mode 100644
index 0000000..a06cd4a
--- /dev/null
+++ b/tests/data/config_sample_4.lio
@@ -0,0 +1,205 @@
+storage fileio {
+    disk file_no_option_2MB {
+        buffered yes 
+        path /tmp/file_no_option_2mb 
+        size 2.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache yes 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 1 
+            max_unmap_lba_count 8192 
+            max_write_same_len 4096 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity 1 
+            unmap_granularity_alignment 0 
+        }
+    }
+    disk file_sparse_1MB {
+        buffered yes 
+        path /tmp/file_sparse_1mb 
+        size 1.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache yes 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 1 
+            max_unmap_lba_count 8192 
+            max_write_same_len 4096 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity 1 
+            unmap_granularity_alignment 0 
+        }
+    }
+    disk file_unbuffered_1MB {
+        buffered yes 
+        path /tmp/file_unbuffered_1mb 
+        size 1.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache yes 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 1 
+            max_unmap_lba_count 8192 
+            max_write_same_len 4096 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity 1 
+            unmap_granularity_alignment 0 
+        }
+    }
+}
+fabric iscsi {
+    discovery_auth {
+        enable no 
+        mutual_password "" 
+        mutual_userid "" 
+        password "" 
+        userid "" 
+    }
+    target iqn.2003-01.org.linux-iscsi.ws0.x8664:sn.31631c361eba tpgt 1 {
+        enable yes 
+        attribute {
+            authentication yes 
+            cache_dynamic_acls no 
+            default_cmdsn_depth 64 
+            default_erl 0 
+            demo_mode_discovery yes 
+            demo_mode_write_protect yes 
+            generate_node_acls no 
+            login_timeout 15 
+            netif_timeout 2 
+            prod_mode_write_protect no 
+        }
+        auth {
+            password "" 
+            password_mutual "" 
+            userid "" 
+            userid_mutual "" 
+        }
+        parameter {
+            AuthMethod CHAP 
+            DataDigest "CRC32C,None" 
+            DataPDUInOrder yes 
+            DataSequenceInOrder yes 
+            DefaultTime2Retain 20 
+            DefaultTime2Wait 2 
+            ErrorRecoveryLevel no 
+            FirstBurstLength 65536 
+            HeaderDigest "CRC32C,None" 
+            IFMarkInt "2048~65535" 
+            IFMarker no 
+            ImmediateData yes 
+            InitialR2T yes 
+            MaxBurstLength 262144 
+            MaxConnections 1 
+            MaxOutstandingR2T 1 
+            MaxRecvDataSegmentLength 8192 
+            MaxXmitDataSegmentLength 262144 
+            OFMarkInt "2048~65535" 
+            OFMarker no 
+            TargetAlias "LIO Target" 
+        }
+        lun 1 backend fileio:file_no_option_2MB 
+        lun 2 backend fileio:file_sparse_1MB 
+        acl iqn.2003-01.org.linux-iscsi.ws0.x8664:client1 {
+            attribute {
+                dataout_timeout 3 
+                dataout_timeout_retries 5 
+                default_erl 0 
+                nopin_response_timeout 30 
+                nopin_timeout 15 
+                random_datain_pdu_offsets no 
+                random_datain_seq_offsets no 
+                random_r2t_offsets no 
+            }
+            auth {
+                password "" 
+                password_mutual "" 
+                userid "" 
+                userid_mutual "" 
+            }
+            mapped_lun 1 {
+                target_lun 1 
+                write_protect no 
+            }
+            mapped_lun 2 {
+                target_lun 2 
+                write_protect no 
+            }
+        }
+        acl iqn.2003-01.org.linux-iscsi.ws0.x8664:client2 {
+            attribute {
+                dataout_timeout 3 
+                dataout_timeout_retries 5 
+                default_erl 0 
+                nopin_response_timeout 30 
+                nopin_timeout 15 
+                random_datain_pdu_offsets no 
+                random_datain_seq_offsets no 
+                random_r2t_offsets no 
+            }
+            auth {
+                password "" 
+                password_mutual "" 
+                userid "" 
+                userid_mutual "" 
+            }
+            mapped_lun 1 {
+                target_lun 1 
+                write_protect no 
+            }
+            mapped_lun 2 {
+                target_lun 2 
+                write_protect no 
+            }
+        }
+    }
+}
+fabric loopback target naa.60014054793b60dd {
+    lun 0 backend fileio:file_no_option_2MB 
+    lun 1 backend fileio:file_sparse_1MB 
+    lun 2 backend fileio:file_unbuffered_1MB 
+}
+fabric vhost target naa.6001405d7e35b513 tpgt 1 lun 0 backend fileio:file_no_option_2MB 
\ No newline at end of file
diff --git a/tests/data/config_sample_5.lio b/tests/data/config_sample_5.lio
new file mode 100644
index 0000000..3a51644
--- /dev/null
+++ b/tests/data/config_sample_5.lio
@@ -0,0 +1,254 @@
+storage fileio {
+    disk disk1 {
+        buffered yes 
+        path /tmp/disk1.img 
+        size 1.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache no 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 0 
+            max_unmap_lba_count 0 
+            max_write_same_len 4096 
+            optimal_sectors 1024 
+            queue_depth 32 
+            unmap_granularity 0 
+            unmap_granularity_alignment 0 
+        }
+    }
+    disk disk2 {
+        buffered yes 
+        path /tmp/disk2.img 
+        size 1.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache no 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count 0 
+            max_unmap_lba_count 0 
+            max_write_same_len 4096 
+            optimal_sectors 1024 
+            queue_depth 32 
+            unmap_granularity 0 
+            unmap_granularity_alignment 0 
+        }
+    }
+}
+storage rd_mcp {
+    disk test {
+        nullio no 
+        size 1.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache no 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count no 
+            max_unmap_lba_count no 
+            max_write_same_len 0 
+            optimal_sectors 1024 
+            queue_depth 32 
+            unmap_granularity no 
+            unmap_granularity_alignment no 
+        }
+    }
+    disk test2 {
+        nullio no 
+        size 1.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache no 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count no 
+            max_unmap_lba_count no 
+            max_write_same_len 0 
+            optimal_sectors 1024 
+            queue_depth 32 
+            unmap_granularity no 
+            unmap_granularity_alignment no 
+        }
+    }
+}
+fabric iscsi {
+    discovery_auth {
+        enable yes 
+        mutual_password no 
+        mutual_userid no 
+        password kjh45fDf_ 
+        userid target1 
+    }
+    target iqn.2003-01.org.linux-iscsi.targetcli.x8664:sn.4699f8812c88 tpgt 1 {
+        enable yes 
+        attribute {
+            authentication no 
+            cache_dynamic_acls no 
+            default_cmdsn_depth 16 
+            default_erl 0 
+            demo_mode_discovery yes 
+            demo_mode_write_protect no 
+            generate_node_acls no 
+            login_timeout 15 
+            netif_timeout 2 
+            prod_mode_write_protect no 
+        }
+        auth {
+            password "" 
+            password_mutual "" 
+            userid "" 
+            userid_mutual "" 
+        }
+        parameter {
+            AuthMethod CHAP 
+            DataDigest "CRC32C,None" 
+            DataPDUInOrder yes 
+            DataSequenceInOrder yes 
+            DefaultTime2Retain 20 
+            DefaultTime2Wait 2 
+            ErrorRecoveryLevel no 
+            FirstBurstLength 65536 
+            HeaderDigest "CRC32C,None" 
+            IFMarkInt "2048~65535" 
+            IFMarker no 
+            ImmediateData yes 
+            InitialR2T yes 
+            MaxBurstLength 262144 
+            MaxConnections 12 
+            MaxOutstandingR2T 34 
+            MaxRecvDataSegmentLength 8192 
+            MaxXmitDataSegmentLength 262144 
+            OFMarkInt "2048~65535" 
+            OFMarker no 
+            TargetAlias "LIO Target" 
+        }
+        lun 1 backend fileio:disk1 
+        lun 2 backend fileio:disk2 
+        acl iqn.2003-01.org.linux-iscsi.targetcli.x8664:client1 {
+            attribute {
+                dataout_timeout 3 
+                dataout_timeout_retries 5 
+                default_erl 0 
+                nopin_response_timeout 30 
+                nopin_timeout 15 
+                random_datain_pdu_offsets no 
+                random_datain_seq_offsets no 
+                random_r2t_offsets no 
+            }
+            auth {
+                password foobar 
+                password_mutual mutupass 
+                userid jerome 
+                userid_mutual just_the2ofus 
+            }
+            mapped_lun 1 {
+                target_lun 1 
+                write_protect no 
+            }
+            mapped_lun 2 {
+                target_lun 1 
+                write_protect no 
+            }
+            mapped_lun 3 {
+                target_lun 1 
+                write_protect no 
+            }
+        }
+        portal 0.0.0.0:3260 
+    }
+    target iqn.2003-01.org.linux-iscsi.targetcli.x8664:sn.caa307436d89 tpgt 1 {
+        enable yes 
+        attribute {
+            authentication yes 
+            cache_dynamic_acls no 
+            default_cmdsn_depth 16 
+            default_erl 0 
+            demo_mode_discovery yes 
+            demo_mode_write_protect yes 
+            generate_node_acls no 
+            login_timeout 15 
+            netif_timeout 2 
+            prod_mode_write_protect no 
+        }
+        auth {
+            password "" 
+            password_mutual "" 
+            userid "" 
+            userid_mutual "" 
+        }
+        parameter {
+            AuthMethod CHAP 
+            DataDigest "CRC32C,None" 
+            DataPDUInOrder yes 
+            DataSequenceInOrder yes 
+            DefaultTime2Retain 20 
+            DefaultTime2Wait 2 
+            ErrorRecoveryLevel no 
+            FirstBurstLength 65536 
+            HeaderDigest "CRC32C,None" 
+            IFMarkInt "2048~65535" 
+            IFMarker no 
+            ImmediateData yes 
+            InitialR2T yes 
+            MaxBurstLength 262144 
+            MaxConnections 1 
+            MaxOutstandingR2T 1 
+            MaxRecvDataSegmentLength 8192 
+            MaxXmitDataSegmentLength 262144 
+            OFMarkInt "2048~65535" 
+            OFMarker no 
+            TargetAlias "LIO Target" 
+        }
+        lun 0 backend rd_mcp:test 
+        lun 1 backend rd_mcp:test2 
+    }
+}
diff --git a/tests/data/config_strings.ast b/tests/data/config_strings.ast
new file mode 100644
index 0000000..c969794
--- /dev/null
+++ b/tests/data/config_strings.ast
@@ -0,0 +1,242 @@
+(lp0
+(lp1
+(dp2
+S'line'
+p3
+I2
+sS'type'
+p4
+S'obj'
+p5
+sS'col'
+p6
+I1
+sS'key'
+p7
+(S'storage'
+p8
+S'fileio'
+p9
+tp10
+sa(dp11
+S'statements'
+p12
+(lp13
+(lp14
+(dp15
+g3
+I3
+sg4
+g5
+sg6
+I5
+sg7
+(S'disk'
+p16
+S'This:is:a_long_name_for_disk'
+p17
+tp18
+sa(dp19
+g12
+(lp20
+(lp21
+(dp22
+g3
+I4
+sg4
+S'attr'
+p23
+sg6
+I9
+sg7
+(S'path'
+p24
+S'/tmp/disk1.img'
+p25
+tp26
+saa(lp27
+(dp28
+g3
+I5
+sg4
+g23
+sg6
+I9
+sg7
+(S'size'
+p29
+S'1MB'
+p30
+tp31
+saa(lp32
+(dp33
+g3
+I7
+sg4
+S'group'
+p34
+sg6
+I9
+sg7
+(S'attribute'
+p35
+tp36
+sa(dp37
+g12
+(lp38
+(lp39
+(dp40
+g3
+I9
+sg4
+g23
+sg6
+I13
+sg7
+(S'block_size'
+p41
+S'512'
+p42
+tp43
+saa(lp44
+(dp45
+g3
+I10
+sg4
+g23
+sg6
+I13
+sg7
+(S'optimal_sectors'
+p46
+S'1024'
+p47
+tp48
+saa(lp49
+(dp50
+g3
+I11
+sg4
+g23
+sg6
+I13
+sg7
+(S'queue_depth'
+p51
+S'32'
+p52
+tp53
+saa(lp54
+(dp55
+g3
+I12
+sg4
+g23
+sg6
+I13
+sg7
+(S'fancy_attribute'
+p56
+S'This is a fancy attribute that takes a long value'
+p57
+tp58
+saa(lp59
+(dp60
+g3
+I14
+sg4
+g23
+sg6
+I13
+sg7
+(S'emulate_tas'
+p61
+S'yes_I_do_want_to_enable_this_%!?@_functionnality!'
+p62
+tp63
+saa(lp64
+(dp65
+S'comment'
+p66
+S'EOL comment'
+p67
+sg3
+I15
+sg4
+g23
+sg6
+I13
+sg7
+(S'enforce_pr_isids'
+p68
+S'yes'
+p69
+tp70
+saa(lp71
+(dp72
+g3
+I17
+sg4
+g23
+sg6
+I13
+sg7
+(S'emulate_dpo'
+p73
+S'no'
+p74
+tp75
+saa(lp76
+(dp77
+g66
+S'Hello there!'
+p78
+sg3
+I18
+sg4
+g23
+sg6
+I13
+sg7
+(S'emulate_tpu'
+p79
+S'no'
+p80
+tp81
+saa(lp82
+(dp83
+g66
+S'Does what it says?'
+p84
+sg3
+I19
+sg4
+g23
+sg6
+I13
+sg7
+(S'is_nonrot'
+p85
+S'no'
+p86
+tp87
+saasg3
+I7
+sg4
+S'block'
+p88
+sg6
+I19
+saasg3
+I3
+sg4
+g88
+sg6
+I39
+saasg3
+I2
+sg4
+g88
+sg6
+I16
+saa.
\ No newline at end of file
diff --git a/tests/data/config_strings.lio b/tests/data/config_strings.lio
new file mode 100644
index 0000000..41ea6e8
--- /dev/null
+++ b/tests/data/config_strings.lio
@@ -0,0 +1,24 @@
+# This is a comment before the first statement
+storage fileio {
+    disk This:is:a_long_name_for_disk {
+        path /tmp/disk1.img
+        size 1MB
+        # This is an indented comment after size and before a group
+        attribute {
+            # This is an indented comment after a group
+            block_size 512
+            optimal_sectors 1024
+            queue_depth 32
+            fancy_attribute "This is a fancy attribute that takes a long value"
+
+            emulate_tas yes_I_do_want_to_enable_this_%!?@_functionnality!
+            enforce_pr_isids yes # EOL comment
+
+            emulate_dpo no
+            emulate_tpu no  # Hello there!
+            is_nonrot no  # Does what it says?
+        }
+    }
+}
+
+# Last words comment
